//CHECKIN 1.0   Mihaly Horvath (Hermit Software Hungary) - 2010 A.D.
// Handles permissions, compression and backups for a central zipped workfile (checking in/out via compression).
//---------------------------------------------------------------------------------------------------------
//----------------------------------------INCLUDES for GUI---------------------------------
#include "resource.h" //for the application icon
#include <string>
#include <windows.h>
#include <commctrl.h>
#include "zip.h"
#include "unzip.h"
using namespace std;

//----------------------------------------Global Variable decllarations-----------------------------
string CentralFile,CentralFilePath,WorkFileName; //central folder and central file
string HomePath,TempWrkDir,TempFile; //the decompressed copy to work on
string ComprExtension = ".zip"; //the extension for backups
string PreBackupPath,PreBackupFile,PostBackupPath,PostBackupFile; //backup path to store the downloaded compressed workfile with actual date in name.
string EditFileExtension = ".edi";
string ActDateTime = "0000";
typedef unsigned long long int64;
int64 Second = 10000000LL, Minute = Second * 60LL, Hour = Minute * 60LL, Day = Hour * 24LL;
DWORD OutdateFileTime = ((Day*7) >> 32);  //one week (1408) is the outdate-time for old files  , 1 hour is 8, value 1 means 7.5 minutes

string ActUserName;
string DelFilePath;
int steps = 7, prog1add = 100 / steps, prog2state, dlgcnt=0, readonly=0;
WIN32_FIND_DATA FindFileData;
HANDLE FindHandle;
string MaintString;
SYSTEMTIME systemTime;
FILETIME filecreatime, filesystime;
DWORD beforetime;
unsigned int BackgroundCol = 0x300000;
char dater[50];

//----------------------------------------Function declarations--------------------------------------
void BuildGUI();
int DecompFile(const char * source, const char * destin);   //workfile decompressor
int CompFile(const char * source, const char * destin, const char * zipfilename);     //file compressor/archiver
void MaintainBU (string Bupath); //backupfile maintainer (deletes outdated files)
string GetCentralPath(string PathAndName);

//-----------------------------------------GUI Declarers---------------------------------------------
#define WinSizeX 200
#define WinSizeY 100
#define WM_TRAYMESSAGE 101
#define ID_5SECONDS 102
#define ID_STATUSBAR 4997
#define ID_MYPROGRESS1 201
#define ID_MYPROGRESS2 202

int funter;
bool showhide = 1;
HWND hwnd;               /* This is the handle for our window */
WNDCLASSEX wincl;        /* Data structure for the windowclass */
HINSTANCE hThisInstance;
HWND status, hwndProgress1;
NOTIFYICONDATA nid;
MSG messages;            /* Here messages to the application are saved */
VOID CALLBACK TimerProc ( HWND hwnd, UINT umsg, UINT eventID, DWORD actime );
/*  Declare Windows procedure  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);
/*  Make the class name into a global variable  */
char szClassName[ ] = "CHECKIN-instance"; //calssname of the frame
//=============================================MAIN FUNCTION===========================================
int WINAPI WinMain (HINSTANCE hInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)

{
    HWND hPrevWnd = FindWindow(szClassName,NULL); //check if an instance already exists
    if(hPrevWnd)
    {
     MessageBox(NULL,"An instance of CHECKIN is running already!","Alert!",MB_OK);
     return FALSE;
    }

 if (*lpszArgument == 0)
 {
  MessageBox(NULL,"Please specify a workfile with full path after the executable's name!\n Alternatively you can either create a shortcut and set the file and path,\n or associate the workfile's extension to this executable file.","Alert!",MB_OK);
  return FALSE;
 }

CentralFile = string(lpszArgument);
  // Remove all double-quote characters
  CentralFile.erase(
    remove( CentralFile.begin(), CentralFile.end(), '\"' ),
    CentralFile.end()
    );

CentralFilePath = GetCentralPath(CentralFile);

    funter = nFunsterStil;
    hThisInstance = hInstance;

    /* The Window structure */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = szClassName;
    wincl.lpfnWndProc = WindowProcedure;      /* This function is called by windows */
    wincl.style = CS_DBLCLKS;                 /* Catch double-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Use default icon and mouse-pointer */
	wincl.hIcon   = static_cast<HICON>(LoadImage(hThisInstance, MAKEINTRESOURCE(IDI_MYICON), IMAGE_ICON,32,32,LR_DEFAULTSIZE));
    wincl.hIconSm = static_cast<HICON>(LoadImage(hThisInstance, MAKEINTRESOURCE(IDI_MYICON), IMAGE_ICON,16,16,LR_DEFAULTSIZE));
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;                 /* No menu */
    wincl.cbClsExtra = 0;                      /* No extra bytes after the window class */
    wincl.cbWndExtra = 0;                      /* structure or the window instance */
    /* Use Windows's default color as the background of the window */
    wincl.hbrBackground = (HBRUSH) COLOR_BACKGROUND;
    //wincl.ShowInTaskbar = false;

    /* Register the window class, and if it fails quit the program */
    if (!RegisterClassEx (&wincl))
        return 0;
        //get screen resolution, set window coordinates
        int winXpos = GetSystemMetrics(SM_CXSCREEN) - 210; 
        int winYpos = GetSystemMetrics(SM_CYSCREEN) - 160;

    /* The class is registered, let's create the program*/
    hwnd = CreateWindowEx (
           WS_EX_TOPMOST | WS_EX_TOOLWINDOW, // | WS_EX_NOACTIVATE,           /* Extended possibilites for variation */
           szClassName,         /* Classname */
           "CHECKIN Helper 1.0 (hermit software hungary)",    /* Window Title Text */
           WS_DISABLED | WS_VISIBLE, // & ~(WS_SIZEBOX) & ~(WS_THICKFRAME), //WS_TILED | WS_DLGFRAME | WS_SYSMENU,
           winXpos, 
           winYpos, 
           WinSizeX,                 /* The programs width */
           WinSizeY,                 /* and height in pixels */
           HWND_DESKTOP,        /* The window is a child-window to desktop */
           NULL,                /* No menu */
           hThisInstance,       /* Program Instance handler */
           NULL                 /* No Window Creation data */
           );

    BuildGUI();  //put controls oin GUI

    //Tray Class Stuff
	    nid.cbSize = sizeof(NOTIFYICONDATA);
	    nid.hWnd = hwnd;
	    nid.uID = 100;
	    nid.uFlags = NIF_ICON|NIF_MESSAGE;
	    nid.hIcon = static_cast<HICON>(LoadImage(hThisInstance, MAKEINTRESOURCE(IDI_MYICON), IMAGE_ICON,16,16,LR_DEFAULTSIZE)); //LoadIcon(hThisInstance,"0");
	    nid.uCallbackMessage = WM_TRAYMESSAGE;
	 
	//Load the tray icon up
	Shell_NotifyIcon(NIM_ADD,&nid);
    /* Make the window visible on the screen */
    ShowWindow (hwnd, nFunsterStil);
    UpdateWindow(hwnd);

//-------------------------------------------------Effective parts -----------------------------------------------------
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//values (path, name, extension of zipped workfile) are taken from source path+file specified as commandline parameter)
//Set up backup and temp directory names from environment variables (user's own home folder)
char * pPath = getenv("USERPROFILE");
HomePath.assign(pPath); 

TempWrkDir = HomePath + "\\CHECKIN\\";  //the decompressed copy to work on
PreBackupPath = TempWrkDir + "PRE-BU\\";   //backup path to store the downloaded compressed workfile with actual date in name.
PostBackupPath = TempWrkDir + "POST-BU\\"; //backup path for the modified (saved) workfile

//------------------------------------------------------------------------------------------------
//STEP 1 - Create directories, get date and time to string: 
SendMessage(status, SB_SETTEXT, 0, (LPARAM)"Creating directories. (If don't exist yet.)");UpdateWindow(hwnd);
if (CreateDirectory(TempWrkDir.c_str(),NULL) == ERROR_PATH_NOT_FOUND)
{
 MessageBox(hwnd,"Workfolder couldn't be created.","Notification!",MB_OK);
 Shell_NotifyIcon(NIM_DELETE,&nid);ShowWindow (hwnd, SW_HIDE); showhide=0; DestroyWindow(hwnd); 
 return 1;
}
CreateDirectory(PostBackupPath.c_str(),NULL); CreateDirectory(PreBackupPath.c_str(),NULL);

SendMessage(hwndProgress1 , PBM_DELTAPOS, prog1add, 0);UpdateWindow(hwnd); 

//----------------------------------------------------------------------------------------------------
//STEP 2 - handle permission, backup-directory maintenance (delete outdated backup files)
SendMessage(status, SB_SETTEXT, 0, (LPARAM)"Checking permissions, who edits the file.");UpdateWindow(hwnd);
const unsigned long BUFSIZE = 255;unsigned long dwSize = BUFSIZE;char pbuf[ BUFSIZE + 1];
GetUserName(pbuf, &dwSize); ActUserName = string(CentralFilePath + "CONTENTS ARE EDITED BY " +  pbuf + "!" + EditFileExtension);
string CheckSomebody = string(CentralFilePath + "*" + EditFileExtension);

if (FindFirstFile(CheckSomebody.c_str(), &FindFileData) != INVALID_HANDLE_VALUE)
{
 readonly = 0;
 string SomebodyString = (string)FindFileData.cFileName + "\n\nWould you like to open workfile without editing?";
 if (MessageBox(hwnd,SomebodyString.c_str(),"Alert! Somebody edits the contents!",MB_YESNO | MB_DEFBUTTON1) == IDYES)
 {
  readonly = 1;
 }
 else
 {
  Shell_NotifyIcon(NIM_DELETE,&nid);ShowWindow (hwnd, SW_HIDE); showhide=0;DestroyWindow(hwnd); 
  DeleteFile(ActUserName.c_str());
  return 2;
 }
}

if (readonly == 0)
{
 if (CreateFile(ActUserName.c_str(), GENERIC_WRITE, FILE_SHARE_DELETE | FILE_SHARE_READ, NULL,CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL) == INVALID_HANDLE_VALUE) //signing editor premission
 {
  MessageBox(hwnd,"Target folder cannot be written!","Notification!",MB_OK);
  Shell_NotifyIcon(NIM_DELETE,&nid);ShowWindow (hwnd, SW_HIDE); showhide=0;DestroyWindow(hwnd); 
  DeleteFile(ActUserName.c_str());
  return 2;
 }
}

//get system date & time for backup file-naming
  GetLocalTime(&systemTime);
  sprintf(dater, "preBackup-%02d%02d%02d-%02d%02d%02d",systemTime.wYear-2000,systemTime.wMonth,systemTime.wDay,systemTime.wHour,systemTime.wMinute,systemTime.wSecond);
  ActDateTime.assign(dater); 

//----maintenance of old backup files
SendMessage(status, SB_SETTEXT, 0, (LPARAM)"Deleting outdated backups.");UpdateWindow(hwnd);
//a.Maintain pre-Backup files
MaintainBU(PreBackupPath);
//b.Maintain post-Backup files
MaintainBU(PostBackupPath);
SendMessage(hwndProgress1 , PBM_DELTAPOS, prog1add, 0);UpdateWindow(hwnd);

//----------------------------------------------------------------------------------------------------
//STEP 3 - Make the pre-backup with date-in-name, before editing document
PreBackupFile = string(PreBackupPath+ActDateTime+ComprExtension);
SendMessage(status, SB_SETTEXT, 0, (LPARAM)"Copying Pre-Backup.");UpdateWindow(hwnd);
if (CopyFile(CentralFile.c_str(), PreBackupFile.c_str(),FALSE) == 0)  //use CopyFileEx to display statusbar
{
 MessageBox(hwnd,"Pre-backup couldn't be copied.","Notification!",MB_OK);
 Shell_NotifyIcon(NIM_DELETE,&nid);ShowWindow (hwnd, SW_HIDE); showhide=0;DestroyWindow(hwnd); 
 DeleteFile(ActUserName.c_str());
 return 3;
}
SendMessage(hwndProgress1 , PBM_DELTAPOS, prog1add, 0);

//-----------------------------------------------------------------------------------------------------
//STEP 4 - Decompress file from saved pre-backup to the working directory
SendMessage(status, SB_SETTEXT, 0, (LPARAM)"Decompressing workfile.");UpdateWindow(hwnd);
if (DecompFile(PreBackupFile.c_str(),TempWrkDir.c_str()) != 0)
{
 MessageBox(hwnd,"Workfile couldn't be decompressed. Busy?","Notification!",MB_OK);
 Shell_NotifyIcon(NIM_DELETE,&nid);ShowWindow (hwnd, SW_HIDE); showhide=0; DestroyWindow(hwnd); 
 DeleteFile(ActUserName.c_str());
 return 4;
}

SendMessage(hwndProgress1 , PBM_DELTAPOS, prog1add, 0);UpdateWindow(hwnd);

//-------------------------------------------------------------------------------------------
//STEP 5 - Open the decompressed file, waiting for closing with/without saving
TempFile = TempWrkDir + WorkFileName;
string QuotedTempFile = "\"" + TempFile + "\"";
SendMessage(status, SB_SETTEXT, 0, (LPARAM)"Opening workfile.");UpdateWindow(hwnd);

if ((int)(ShellExecute(hwnd, NULL, QuotedTempFile.c_str(), NULL, NULL, SW_SHOWNORMAL)) <= 32)
{
 MessageBox(hwnd,"Application couldn't be opened.","Notification!",MB_OK);
 Shell_NotifyIcon(NIM_DELETE,&nid);ShowWindow (hwnd, SW_HIDE); showhide=0; DestroyWindow(hwnd); 
 DeleteFile(ActUserName.c_str());
 return 5;
}

if (readonly != 0) goto Finished;

ShowWindow (hwnd, SW_HIDE); showhide=0;UpdateWindow(hwnd);
SendMessage(hwndProgress1 , PBM_DELTAPOS, prog1add, 0);UpdateWindow(hwnd);

retrier:
while (GetMessage (&messages, NULL, 0, 0)) //Run the message loop. It will run until GetMessage() returns 0  (tray icon pushed)
{
        // Translate virtual-key messages into character messages
        TranslateMessage(&messages);
        // Send message to WindowProcedure
        DispatchMessage(&messages);
}

//--------------------------------------------------------------------------------------------
//STEP 6 - Compress workfile, copy to post-backup directory
GetLocalTime(&systemTime);
sprintf(dater, "postBackup-%02d%02d%02d-%02d%02d%02d",systemTime.wYear-2000,systemTime.wMonth,systemTime.wDay,systemTime.wHour,systemTime.wMinute,systemTime.wSecond);
ActDateTime.assign(dater); 
PostBackupFile = string(PostBackupPath+ActDateTime+ComprExtension);
SendMessage(status, SB_SETTEXT, 0, (LPARAM)"Compressing post-backup.");UpdateWindow(hwnd);

ShowWindow (hwnd, nFunsterStil); UpdateWindow(hwnd); showhide=1;
if (CompFile(TempFile.c_str(), PostBackupFile.c_str(), WorkFileName.c_str()) != 0)
{
 ShowWindow (hwnd, SW_HIDE); showhide=0;
 DeleteFile(PostBackupFile.c_str());
 dlgcnt = 1;
 MessageBox(hwnd,"Workfile couldn't be compressed. Busy?","Notification!",MB_OK); //was left open ...
 dlgcnt = 0;
 goto retrier;
}
SendMessage(hwndProgress1 , PBM_DELTAPOS, prog1add, 0);UpdateWindow(hwnd);

//-----------------------------------------------------------------------------------------------
//STEP 7 - Copy last postBackup back to central directory, handle premissions
SendMessage(status, SB_SETTEXT, 0, (LPARAM)"Saving workfile...");UpdateWindow(hwnd);

retrier2:
if (CopyFile(PostBackupFile.c_str(),CentralFile.c_str(),FALSE) == 0)
{
 dlgcnt = 1;
 if (MessageBox(hwnd,"The workfile couldn't be saved! \nTry again or exit?","Notification!",MB_YESNO | MB_DEFBUTTON1) == IDNO)
 {
  Shell_NotifyIcon(NIM_DELETE,&nid);ShowWindow (hwnd, SW_HIDE); showhide=0; DestroyWindow(hwnd); 
  DeleteFile(ActUserName.c_str());
  return 7;
 }
 dlgcnt = 0;
 goto retrier2;
}

SendMessage(hwndProgress1 , PBM_DELTAPOS, prog1add, 0);
SendMessage(hwndProgress1, PBM_SETPOS, 100, 0);UpdateWindow(hwnd);

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
Finished:
 DeleteFile(ActUserName.c_str());
 Shell_NotifyIcon(NIM_DELETE,&nid);
 ShowWindow (hwnd, SW_HIDE); showhide=0; 
 DestroyWindow(hwnd); 
 return 0;

}

//-----------------------------------------------EVENT HANDLER-----------------------------------------------
/*  This function is called by the Windows function DispatchMessage()  */

LRESULT CALLBACK WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
 switch (message)                  /* handle the messages */
 {
  case WM_TRAYMESSAGE:
  {
   switch(lParam)
   {
    case WM_LBUTTONUP: 
    {
     if (dlgcnt == 0)
     {
      PostQuitMessage (0);
     }
     break;
    }
    case WM_RBUTTONUP: 
    {
     if (dlgcnt == 0)
     {
      dlgcnt=1;
      if (MessageBox(hwnd,"Do you really want to lose changes?","Quit before saving work?",MB_YESNO | MB_DEFBUTTON2) == IDYES)
      {
       DeleteFile(ActUserName.c_str());
       Shell_NotifyIcon(NIM_DELETE,&nid);
       ShowWindow (hwnd, SW_HIDE); showhide=0; 
       DestroyWindow(hwnd);
       ExitProcess(10);break;
      }
      else
      {
       dlgcnt = 0;
       break;
      }
     }
    }
   }
   break;
  }

  case WM_DESTROY:
  {
   DeleteFile(ActUserName.c_str());
   Shell_NotifyIcon(NIM_DELETE,&nid);
   ShowWindow (hwnd, SW_HIDE); showhide=0; 
   DestroyWindow(hwnd);
   ExitProcess(11);       
   break;
  }

  default:                      /* for messages that we don't deal with */
   return DefWindowProc (hwnd, message, wParam, lParam);
 }
 return 0;
}

//===========================================MAKE UP GUI SURFACE, PUT CHILDS=================================
void BuildGUI()
{

//create status bar
status=CreateWindowEx(0,STATUSCLASSNAME,NULL,WS_CHILD|WS_VISIBLE|SBARS_SIZEGRIP,
                    0,0,0,0,hwnd,(HMENU)ID_STATUSBAR,GetModuleHandle(NULL),NULL);
SendMessage(status, SB_SETTEXT, 0, (LPARAM)"CHECKIN by Mihaly Horvath (Hermit)");    

//create progress bar 1 (overall)
hwndProgress1 = CreateWindow(
			PROGRESS_CLASS,		/*The name of the progress class*/
			NULL, 			/*Caption Text*/
			WS_CHILD | WS_VISIBLE,	/*Styles*/
			5, 			/*X co-ordinates*/
			40, 			/*Y co-ordinates*/
			185, 			/*Width*/
			15, 			/*Height*/
			hwnd, 			/*Parent HWND*/
			(HMENU) ID_MYPROGRESS1, 	/*The Progress Bar's ID*/
			hThisInstance,		/*The HINSTANCE of your program*/ 
			NULL);			/*Parameters for main window*/
SendMessage(hwndProgress1, PBM_SETBARCOLOR, 0, 0x508000);
SendMessage(hwndProgress1, PBM_SETBKCOLOR, 0,  BackgroundCol);
//SetBkColor(GetDC(hwnd),BackgroundCol);

	CreateWindowEx(0,
		       "STATIC",
		       "The overall process",
		       WS_CHILD | WS_VISIBLE,
		       30, 10, 130, 25,
		       hwnd,
		       NULL,
		       hThisInstance,
		       NULL);
}

//================================================COMPRESSION FUNCTIONS======================================
int DecompFile(const char * source, const char * destin)
{
  int errormsg;
  HZIP hz = OpenZip(source,0); string filenamepath;
  ZIPENTRY ze; GetZipItem(hz,-1,&ze); int numitems=ze.index;
  // -1 gives overall information about the zipfile
  for (int zi=0; zi<numitems; zi++)
  { ZIPENTRY ze; GetZipItem(hz,zi,&ze); // fetch individual details
    WorkFileName = string(ze.name);
    filenamepath = string(destin + WorkFileName);
    errormsg = UnzipItem(hz, zi, filenamepath.c_str());         // e.g. the item's name.
  }
  CloseZip(hz);

 return errormsg;
}

int CompFile(const char * source, const char * destin, const char * zipfilename)
{
  int errormsg;
  HZIP hz = CreateZip(destin,0);
  errormsg = ZipAdd(hz,zipfilename, source);
  CloseZip(hz);

 return errormsg;
}

//-----------------------------------backup-file maintainer function -----------------------------------------
void DeleteOutDated(string BUpath)
 {
  filecreatime = FindFileData.ftCreationTime;    
  if(SystemTimeToFileTime(&systemTime,&filesystime) != 0)
  {
   beforetime = filesystime.dwHighDateTime - OutdateFileTime;
    //sprintf(dater,"%d %d %d",filecreatime.dwHighDateTime,filesystime.dwHighDateTime,beforetime);
    //MessageBox(hwnd,dater,"filedate, systemdate, expiredate (systemtime-days)",MB_OK);
   if (filecreatime.dwHighDateTime < beforetime)
   {
    DelFilePath = BUpath + (string)FindFileData.cFileName;
    DeleteFile(DelFilePath.c_str());
   }
  }
 }

void MaintainBU (string BackupPath)
 {
  GetSystemTime(&systemTime);
  MaintString = string(BackupPath + "*" + ComprExtension);
  FindHandle = FindFirstFile(MaintString.c_str(), &FindFileData);
  if ( FindHandle != INVALID_HANDLE_VALUE)
  {
   DeleteOutDated(BackupPath);
  }
  while (FindNextFile(FindHandle, &FindFileData) != 0)
  {
   DeleteOutDated(BackupPath);
  }
 }
 
 //---------------------------------getpath from file path+name-------------------------------------

string GetCentralPath(string PathAndName)
{
 size_t found;      
 found=PathAndName.find_last_of("/\\");
 PathAndName = PathAndName.substr(0,found+1);
 return PathAndName;
}

//===========================================================EOF================================================
